<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="需求单id" prop="userId">
        <el-input
          v-model="queryParams.id"
          placeholder="请输入需求单id"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="用户id" prop="userId">
        <el-input
          v-model="queryParams.userId"
          placeholder="请输入用户id"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="需求开始日期" prop="reqStartDate" label-width="100">
        <el-date-picker
          v-model="queryParams.reqStartDate"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="需求结束日期" prop="reqEndDate" label-width="100">
        <el-date-picker
          v-model="queryParams.reqEndDate"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="需求状态" prop="status">
        <el-select
          v-model="queryParams.status"
          placeholder="请选择需求状态"
          clearable
          class="!w-240px"
        >
          <el-option label="已过期" :value="5" />
          <el-option label="已完成" :value="4" />
          <el-option label="上户中" :value="3" />
          <el-option label="已接单" :value="2" />
          <el-option label="已发布" :value="1" />
          <el-option label="未发布" :value="0" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['yuesao:request:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['yuesao:request:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="需求单id" align="center" prop="id" />
      <el-table-column label="用户id" align="center" prop="userId" />
      <el-table-column
        label="需求开始日期"
        align="center"
        prop="reqStartDate"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column
        label="需求结束日期"
        align="center"
        prop="reqEndDate"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="工资上限" align="center" prop="upSalary" />
      <el-table-column label="工资下限" align="center" prop="downSalary" />
      <el-table-column label="是否为单胎" align="center" prop="isSingleBaby" min-width="100">
        <template #default="{ row }">
          {{ row.isSingleBaby ? '是' : '不是' }}
        </template>
      </el-table-column>
      <el-table-column label="上户区域" align="center" prop="workArea" min-width="250" />
      <el-table-column label="需求状态" align="center" prop="status" min-width="150">
        <template #default="{ row }">
          <el-tag v-if="needConf[row.status]">{{ needConf[row.status] }}</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="是否为急单" align="center" prop="isRushReq" min-width="100">
        <template #default="{ row }">
          {{ row.isRushReq ? '是' : '不是' }}
        </template>
      </el-table-column>
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="上户周期" align="center" prop="reqCycle" />
      <!-- <el-table-column label="区域id" align="center" prop="areaId" /> -->
      <el-table-column label="操作" align="center" fixed="right" min-width="250">
        <template #default="scope">
          <el-button link type="primary" @click="onStatus(scope.row)">修改需求单状态</el-button>

          <el-popconfirm :title="scope.row.isRushReq ? '确定设为非急单?' : '确定设为急单?'" width="250px" @confirm="onSetRush(scope.row.id)">
            <template #reference>
              <el-button link type="danger">{{ scope.row.isRushReq ? '设为非急单' : '设为急单' }}</el-button>
            </template>
          </el-popconfirm>

        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <RequestForm ref="formRef" @success="getList" />
  <StatusDialog ref="dialogRef" @success="getList" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import * as RequestApi from '@/api/request'
import RequestForm from './RequestForm.vue'
import StatusDialog from './StatusDialog.vue';
import { needConf } from './const';

defineOptions({ name: 'Request' })

const route = useRoute();
const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const total = ref(0) // 列表的总页数
const list = ref([]) // 列表的数据
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  id: null,
  userId: null,
  reqStartDate: [],
  reqEndDate: [],
  upSalary: null,
  downSalary: null,
  allowConnect: null,
  isSingleBaby: null,
  workArea: null,
  remark: null,
  status: null,
  isRushReq: null,
  createTime: [],
  reqCycle: null,
  areaId: null
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await RequestApi.getRequestPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

const dialogRef = ref()
const openDialog = (id?: number, status?: RequestApi.NeedStatus) => {
  dialogRef.value.open(id, status)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await RequestApi.deleteRequest(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await RequestApi.exportRequest(queryParams)
    download.excel(data, '需求.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

const onSetRush = async (id: number) => {
  try {
    await RequestApi.setRushRequest({ id });
    message.success(t('common.updateSuccess'))
    await getList()
  } catch {}
};

const onStatus = (item: RequestApi.RequestVO) => {
    openDialog(item.id, item.status);
}

/** 初始化 **/
onMounted(() => {
  if (route.query.id) {
    // @ts-ignore
    queryParams.id = Number(route.query.id);
  }
  if (route.query.userId) {
    // @ts-ignore
    queryParams.userId = Number(route.query.userId);
  }
  getList()
})
</script>
